require "defines"

local chest
local loaded

game.onload(function()
	if not loaded then
		loaded = true
		if glob.canCraftChest ~= false then
			game.forces.player.recipes["heavy-chest"].enabled = game.forces.player.technologies["steel-processing"].researched
		end
		
		if glob.chest ~= nil then
			chest = glob.chest
		end
	end
end)

game.oninit(function()
	loaded = true
	
	if glob.canCraftChest ~= false then
		game.forces.player.recipes["heavy-chest"].enabled = game.forces.player.technologies["steel-processing"].researched
	end
end)

game.onevent(defines.events.onpreplayermineditem, function(event)
	local chestHasContents
	local chestContents
	local itemName
	local countBefore
	local countAfter
	
	if event.entity.name == "heavy-chest" then
		if chest == nil then
			chestContents = event.entity.getinventory(1).getcontents()
			
			for k,v in pairs(chestContents) do
				chestHasContents = true
				break
			end
			
			if chestHasContents then
				glob.chest = chestContents
				chest = glob.chest
				event.entity.getinventory(1).clear()
				
				itemName = "heavy-chest-picked-up"
			end
		end
		
		if itemName == nil then
			itemName = "heavy-chest"
		end
		
		countBefore = game.player.getitemcount(itemName)
		game.player.insert({name = itemName, count = 1})
		countAfter = game.player.getitemcount(itemName)
		if countBefore == countAfter then
			game.createentity({name = "item-on-ground", position = event.entity.position, stack = {name = itemName, count = 1}})
		end
		
--		if game.player.caninsert({name = itemName, count = 1}) then
--			game.player.insert({name = itemName, count = 1})
--		else
--			game.createentity({name = "item-on-ground", position = entity.position, stack = {name = itemName, count = 1}})
--		end
	end
end)

game.onevent(defines.events.onbuiltentity, function(event)
	local newChest
	
	if event.createdentity.name == "heavy-chest-picked-up" then
		newChest = game.createentity({name = "heavy-chest", position = event.createdentity.position, force = game.forces.player})
		event.createdentity.destroy()
		
		if chest ~= nil then
			for k,v in pairs(chest) do
				newChest.getinventory(1).insert({name = k, count = v})
			end
			chest = nil
			glob.chest = nil
		end
	end
end)

function removeHeavyChest()
	game.player.removeitem({name = "heavy-chest", count = 1})
	game.onevent(defines.events.ontick, nil)
end

game.onevent(defines.events.onplayercrafteditem , function(event)
	if event.itemstack.name == "heavy-chest" then
		if glob.canCraftChest ~= false and game.forces.player.recipes["heavy-chest"].enabled then
			game.forces.player.recipes["heavy-chest"].enabled = false
			glob.canCraftChest = false
		else
			local insertedCount = 0
			local steelBefore
			local steelAfter
			
			if game.player.getitemcount("heavy-chest") == 0 then
				game.onevent(defines.events.ontick, removeHeavyChest)
			else
				game.player.removeitem(event.itemstack)
			end
			
			steelBefore = game.player.getitemcount("steel-plate")
			game.player.insert({name = "steel-plate", count = 1600})
			steelAfter = game.player.getitemcount("steel-plate")
			if steelAfter ~= steelBefore then
				insertedCount = steelAfter - steelBefore
			end
			
			if insertedCount ~= 1600 then
				for n = 1,1600-insertedCount,1 do
					game.createentity({name = "item-on-ground", position = game.findnoncollidingposition("item-on-ground", game.player.position, 30, 0.2), stack = {name = "steel-plate", count = 1}})
				end
			end
			
			game.player.print("You can only have one Heavy Chest at a time.")
		end
	end
end)

game.onevent(defines.events.onentitydied, function(event)
	if event.entity.name == "heavy-chest" then
		glob.canCraftChest = nil
		game.forces.player.recipes["heavy-chest"].enabled = game.forces.player.technologies["steel-processing"].researched
	end
end)